From 1706132f06f9197a77b2cbb65e2e5e38d719b256 Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Thu, 21 Oct 2021 16:24:25 +0200
Subject: [PATCH] fontenay-sous-bois-2018: update site logo (#58061)

---
 .../img/logo-fontenay.png                     | Bin 24933 -> 13494 bytes
 .../fontenay-sous-bois-2018/theme.html        |   2 +-
 2 files changed, 1 insertion(+), 1 deletion(-)

diff --git a/static/fontenay-sous-bois-2018/img/logo-fontenay.png b/static/fontenay-sous-bois-2018/img/logo-fontenay.png
index 6e15a6ae8c70423bf1fd7afae9c29e0a3911e11d..831dd1a505d76b6106ae071bfe9de5d5bfd185ed 100644
GIT binary patch
diff --git a/templates/variants/fontenay-sous-bois-2018/theme.html b/templates/variants/fontenay-sous-bois-2018/theme.html
index ab53fb21..203ec315 100644
--- a/templates/variants/fontenay-sous-bois-2018/theme.html
+++ b/templates/variants/fontenay-sous-bois-2018/theme.html
@@ -3,7 +3,7 @@
 
 {% block header-pre %}
 <div id="header-pre"><div>
-<a id="logo-ville" href="{{website_url}}"><img width="369" height="78" src="{{ site_base }}{% static 'fontenay-sous-bois-2018/img/logo-fontenay.png' %}" alt="fontenay-sous-bois.fr"/></a>
+<a id="logo-ville" href="{{website_url}}"><img width="165" height="78" src="{{ site_base }}{% static 'fontenay-sous-bois-2018/img/logo-fontenay.png' %}" alt="fontenay-sous-bois.fr"/></a>
 <a id="home-link" href="{{portal_url}}">Mes démarches</a>
 </div></div>
 {% endblock %}
-- 
2.33.0